#!/bin/bash
#
# smbclient command generator, send any questions to ddiss@suse.de
#
# Copyright (C) David Disseldorp 2014
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SCRIPT_NAME=`basename $0`
#LOG_FILE=./$$-${SCRIPT_NAME}.log
LOG_FILE=/dev/null
SRC_DATA_FILE="$1"
OUT_SUB_DIR="$2"

function _log
{
        echo "$(date +%d-%h-%H:%M:%S) $*" >> $LOG_FILE
}

function _usage
{
	_log "$SCRIPT_NAME invalid args: $*"
	_log ""
	_log "usage: $SCRIPT_NAME <src_file> <tgt_sub_dir>"
	exit 1
}

function _put
{
        local rem_file=$1
        echo "put $SRC_DATA_FILE $rem_file"
}

function _get
{
        local rem_file=$1
        echo "get $rem_file /dev/null"
}

function _del
{
        local rem_file=$1
        echo "del $rem_file"
}

function _mkdir
{
        local rem_dir=$1
        echo "mkdir $rem_dir"
}

[ -z "$SRC_DATA_FILE" ] && _usage "src_file not set"
[ -z "$OUT_SUB_DIR" ] && _usage "tgt_sub_dir not set"

_log "creating ${OUT_SUB_DIR}"
_mkdir "${OUT_SUB_DIR}"

while [ 1 ]; do
	sleep_len=$(expr 2 + $RANDOM % 2)
        _log "starting write jobs"
        for i in $(seq 1 1); do
#                _put "${OUT_SUB_DIR}\file${i}"
                sleep 0.001
        done

        sleep $sleep_len

        _log "starting read jobs"
        for i in $(seq 1 1); do
#                _get "${OUT_SUB_DIR}\file${i}"
                sleep 0.001
        done

        sleep $sleep_len

        _log "starting removal jobs"
        for i in $(seq 1 1); do
#                _del "${OUT_SUB_DIR}\file${i}"
                sleep 0.001
        done

        sleep $sleep_len
done
